<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-dialog
			:title="title"
			:close-on-click-modal="false"
			draggable
			width="1300px"
			@close="close"
			@keyup.enter.native=""
			v-model="visible">
		<el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''" :disabled="method === 'view'"
				 label-width="160px" @submit.native.prevent>
			<el-divider content-position="left"><i class="el-icon-document"></i>
				<span style="color: red;border-top: 20px">*</span>用车项目
				<el-button style="margin-left: 20px" type="primary" :readonly="true" :disabled="method === 'view'"  @click="insertEvent('base')"  plain>
					新增
				</el-button>
			</el-divider>
			<el-row  :gutter="15">
				<el-col :span="24">
					<vxe-table
						border
						:footer-method="footerMethod2"
						show-overflow
						show-footer
						ref="baseTable"
						:key="baseKey"
						class="vxe-table-element"
						:data="inputForm.projectList"
						style="margin-left: 5em"
						@cell-click=""
						@edit-closed=""
						keep-source
						:readonly="true"
						:disabled="method === 'view'"
						highlight-current-row
						:edit-rules="tableRules"
						:edit-config="{trigger: 'click', mode: 'cell', showStatus: true, autoClear: true, icon: '-'}"
					>
						<vxe-table-column field="name" align="center" title="项目名称" :edit-render="{}" show-overflow="title">
							<template v-slot:edit="scope">
								<el-input :disabled="method === 'view'"   @focus="openProgramPageForm(scope.$rowIndex)" placeholder="请填写项目名称" :readonly="true" v-model="scope.row.name"/>
							</template>
						</vxe-table-column>
						<vxe-table-column field="no" align="center" title="项目编号" :edit-render="{}">
							<template v-slot:edit="scope">
								<el-input  :readonly="true" placeholder="请填写项目编号" v-model="scope.row.no"/>
							</template>
						</vxe-table-column>
						<vxe-table-column  field="leader" align="center" title="项目负责人" :edit-render="{}">
							<template v-slot:edit="scope">
								<el-input  placeholder="请填写项目负责人" v-model="scope.row.leader"/>
							</template>
						</vxe-table-column>
						<vxe-table-column field="createTime" align="center" title="创建时间" :edit-render="{}">
							<template v-slot:edit="scope">
								<el-input  placeholder="请填写创建时间" v-model="scope.row.createTime"/>
							</template>
						</vxe-table-column>
						<vxe-table-column title="操作" align="center" width="100">
							<template v-slot="scope">
								<el-button :disabled="method === 'view'"  type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'base')">删除</el-button>
							</template>
						</vxe-table-column>
					</vxe-table>
				</el-col>
			</el-row>

			<el-divider content-position="left"><i class="el-icon-document"></i>
				基本信息
			</el-divider>
			<el-row  :gutter="15">
				<el-col :span="12">
					<el-form-item label="出差人员" prop="evectionMen"
								  :rules="[ {required: true, message:'用车人员不能为空', trigger:'blur'}]">
						<UserSelectSignatory style="width: 100%" ref="userSelect2"
											 :readonly="true" :modelValue="inputForm.evectionMen"
											 @update:modelValue='(value) => {inputForm.evectionMen = value}'></UserSelectSignatory>					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="出差起止时间" prop="useDate"
								  :rules="[
								  {required: true, message:'用车起止时间不能为空', trigger:'blur'}]">
						<el-date-picker
							v-model="inputForm.useDate"
							type="daterange"
							start-placeholder="请选择开始时间"
							end-placeholder="请选择结束时间"
							value-format="YYYY-MM-DD"
						/>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item prop="targetCity" label="目的地"
								  :rules="[ {required: true, message:'目的地不能为空', trigger:'blur'}]">
						<SelectTree
							ref="areaTree"
							:props="{
                    value: 'id',             // ID字段名
                    label: 'name',         // 显示名称
                    children: 'children'    // 子级字段名
                  }"
							url="/system-server/sys/area/treeData"
							:value="inputForm.targetCity"
							:clearable="true"
							:accordion="true"
							size="default"
							@getValue="(value) => {inputForm.targetCity=value}"/>
					</el-form-item>
				</el-col>
				<el-col :span="24">
					<el-form-item label="出差原因" prop="evectionReason"
								  :rules="[ {required: true, message:'出差原因不能为空', trigger:'blur'}]">
						<el-input :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" type="textarea" placeholder="请输入说明"  maxlength="500"  style="width:100%" v-model="inputForm.evectionReason" show-word-limit></el-input>
					</el-form-item>
				</el-col>

				<el-col :span="24">
					<el-form-item label="备注" prop="remarks"
								  :rules="[ ]">
						<el-input :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" type="textarea" placeholder="请输入说明"  maxlength="500"  style="width:100%" v-model="inputForm.remarks" show-word-limit></el-input>
					</el-form-item>
				</el-col>
			</el-row>

		</el-form>
			<UpLoadComponent ref="uploadComponent"></UpLoadComponent>

		<ProjectForm ref="projectForm" @getProgram="getProgram"></ProjectForm>
			<template #footer>
			<span class="dialog-footer">
			  <el-button  @click="close()" icon="el-icon-circle-close">关闭</el-button>
			  <el-button  type="primary" v-if="method != 'view'" @click="doSubmit()" icon="el-icon-circle-check" v-noMoreClick>确定</el-button>
			</span>
			</template>
		</el-dialog>
	</div>
</template>

<script>
	import XEUtils from 'xe-utils'
	import EvectionService from '@/api/jy/EvectionService'
	import { ElDatePicker } from 'element-plus';
	import ProjectForm from '../drive/ProjectForm'
	import UserSelectSignatory from '../workClientInfo/clientUserSelect'
	import UpLoadComponent from '@/views/common/UpLoadComponent'
	import CommonApi from '@/api/cw/common/CommonApi'
	import SelectTree from '@/components/treeSelect/treeSelect.vue'
	export default {
		props: {
			businessId: {
				type: String,
				default: ''
			},
			formReadOnly: {
				type: Boolean,
				default: false
			},
			status: {
				type: String,
				default: ''
			}
		},
		data () {
			return {
				title: '',
				method: '',
				loading: false,
				visible: false,
				inputForm: {
					id: '',
					evectionMen:'',
					evectionReason: '',
					startTime:'',
					endTime:'',
					remarks: '',
					projectList:[],
					files: [], // 附件信息
					procInsId: '',
					targetCity:'',
					useDate:[],
				},
				baseKey: '',
				keyWatch: '',
				dateList:[],
				programRow:'',

			}
		},
		EvectionService:null,
		commonApi: null,
		created () {
			this.evectionService=new EvectionService()
			this.commonApi = new CommonApi()
		},
		mounted () {
		},
		activated () {
		},
		components: {
			ElDatePicker,
			ProjectForm,
			UserSelectSignatory,
			UpLoadComponent,
			SelectTree,
		},
		computed: {
			bus: {
				get () {
					this.$refs.uploadComponent.setDividerName('附件')
					return this.businessId
				},
				set (val) {
					this.businessId = val
				}
			}
		},
		watch: {
			'keyWatch': {
				handler (newVal) {
					if (this.bus) {
						if (this.bus !== 'false') {
							this.init('', this.bus)
						}
					} else {
						this.$nextTick(() => {
							this.$refs.inputForm.resetFields()
						})
					}
				}
			},
			'loading': {
				handler (newVal) {
					this.$emit('changeLoading', newVal)
					this.$refs.uploadComponent.changeLoading(newVal)
				}
			}
		},
		methods: {
			getKeyWatch(keyWatch) {
				this.keyWatch = keyWatch
			},
			init(method, id) {
				this.method = method
				this.inputForm={
					id: '',
					useMen:'',
					useReason: '',
					useDate:[],
					remarks: '',
					projectList:[],
					files: [], // 附件信息
					procInsId: '',
					targetCity:'',
				}
				this.inputForm.id = id
				this.loading = false
				this.visible= true
				if (method === 'edit'){
					this.title = '修改出差信息'
				}else if (method === 'view'){
					this.title = '查看出差信息'
				}
				this.$nextTick(() => {
					this.$refs.inputForm.resetFields()
					this.loading = true
					this.$refs.uploadComponent.clearUpload()
					if (this.commonJS.isNotEmpty(this.inputForm.id)) {
						console.log('this.inputForm.id', this.inputForm.id)
						this.evectionService.queryById(this.inputForm.id).then((data)=>{
							this.inputForm = this.recover(this.inputForm, data)
							this.inputForm.files=data.files
							console.log('s',this.inputForm)
							if (this.status === 'audit' || this.status === 'taskFormDetail') {
								method = 'view'
							}
							console.log('me',method)
							this.$refs.uploadComponent.newUpload(method, this.inputForm.files, 'evection',null,null,null,null,null)
							this.loading = false
						})

					}
				})
			},
			saveForm(callback) {
				this.doSubmit('save', callback)
			},
			startForm(callback) {
				this.loading = true
				if (this.commonJS.isNotEmpty(this.inputForm.id)) {
					this.evectionService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '0' && data.status !== '1' && data.status !== '3') { // 审核状态不是“未发起”或“暂存”或“撤回”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							this.doSubmit('start', callback)
						}
					})
				} else {
					this.doSubmit('start', callback)
				}
			},
			async agreeForm(callback) {
				console.log('进入方法')
				this.loading = true
				await this.evectionService.queryById(this.inputForm.id).then((data) => {
					if (data.status !== '2' ) { // status的值不等于“审核中”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error()
					} else {
						this.inputForm.status= '2'
						this.commonApi.getTaskNameByProcInsId(this.inputForm.procInsId).then((data)=>{
							if (this.commonJS.isNotEmpty(data)) {
								if (data === '总经理审核') {
									this.inputForm.status = '5'
								}
							}
							let param = {status: this.inputForm.status, id: this.inputForm.id}
							this.inputForm=JSON.stringify(this.inputForm)
							this.evectionService.updateStatusById(param).then(() => {
								callback(data.businessTable, data.businessId, this.inputForm)
								this.loading = false
							}).catch(() => {
								this.loading = false
							})
						})
					}
				})
			},
			reapplyForm(callback) {
				this.loading = true
				this.evectionService.queryById(this.inputForm.id).then((data) => {
					if (data.status !== '4') { // 审核状态不是“驳回”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.doSubmit('reapply', callback)
					}
				})
			},
			// 表单提交
			async doSubmit(status, callback) {
				this.loading = true
				console.log('5',this.inputForm)
				if (status === 'save') {
					// 暂存
					this.loading = true
					this.inputForm.status = '1'
					if (this.inputForm.useDate !== undefined ||this.inputForm.useDate !== null || this.inputForm.useDate.length !== 0){
						this.inputForm.startTime=this.inputForm.useDate[0]
						this.inputForm.endTime=this.inputForm.useDate[1]
					}
					if (this.$refs.uploadComponent.checkProgress()) {
						this.loading = false
						return
					}
					this.inputForm.files = this.$refs.uploadComponent.getDataList()
					this.evectionService.saveForm(this.inputForm).then((data) => {
						callback(data.businessTable, data.businessId, this.inputForm)
						this.loading = false
					}).catch(() => {
						this.loading = false
					})
					return
				} else if (status === 'start') {
					if (this.inputForm.projectList.length ===0) {
						this.$message.error('请选择用车项目')
						this.loading = false
					}
					if (this.inputForm.useDate == undefined ||this.inputForm.useDate == null || this.inputForm.useDate.length <= 0 ) {
						this.$message.error('请选择用车时间')
						this.loading = false
					}
					if (this.commonJS.isEmpty(this.inputForm.evectionMen)){
						this.$message.error('请选择出差人员')
						this.loading = false
					}
					if (this.commonJS.isEmpty(this.inputForm.evectionReason)){
						this.$message.error('请选择出差原因')
						this.loading = false
					}
					if (this.commonJS.isEmpty(this.inputForm.targetCity)){
						this.$message.error("请选择目的地")
						this.loading=false
					}
					this.inputForm.startTime=this.inputForm.useDate[0]
					this.inputForm.endTime=this.inputForm.useDate[1]
					if (this.$refs.uploadComponent.checkProgress()) {
						this.loading = false
						return
					}
					this.inputForm.files = this.$refs.uploadComponent.getDataList()
					// 送审  待审核
					this.inputForm.status = '2'
				} else if (status === 'agree') {
					this.inputForm.status= '5'
				} else if (status === 'reapply') {
					this.inputForm.status = '2'
				}
				this.$refs['inputForm'].validate((valid) => {
					if (valid) {
						this.loading = true
						console.log('form',this.inputForm)
						this.inputForm.startTime=this.inputForm.useDate[0]
						this.inputForm.endTime=this.inputForm.useDate[1]
						this.evectionService.adminEditForm(this.inputForm).then((data) => {
							this.visible = false
							this.$emit('refreshList')

						}).catch(() => {
							this.$refs.inputForm.resetFields()
							this.loading = false
						})
					} else {
						this.loading = false
					}
				})
			},
			close() {
				this.inputForm = {
					id: '',
					useMen:'',
					useReason: '',
					useDate:[],
					remarks: '',
					projectList:[],
					files: [], // 附件信息
					procInsId: '',
					targetCity:'',
				}
				this.visible = false
			},
			async updateStatusById(type, callback) {
				this.loading = true
				if (type === 'reject' || type === 'reback') {
					this.evectionService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '2') { // status的值不等于“审核中”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							// if (type === 'agree') {
							//   // 同意
							//   this.inputForm.status = '5'
							// }
							if (type === 'reject') {
								// 驳回
								this.inputForm.status = '4'
							}
							if (type === 'reback') {
								// 撤回
								this.inputForm.status = '3'
							}
							if (type === 'reject' || type === 'reback') {
								let param = {status: this.inputForm.status, id: this.inputForm.id}
								this.evectionService.updateStatusById(param).then(() => {
									this.loading = false
									callback()
								})
							}
						}
					})
				} else if (type === 'hold') {
					this.evectionService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '4') { // status的值不等于“驳回”就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							// 终止
							let param = {status: '1', id: this.inputForm.id}
							this.evectionService.updateStatusById(param).then(() => {
								this.loading = false
								callback()
							})
						}
					})
				}

			},
			insertEvent(type) {
				if (type === 'base') {
					if (this.inputForm.projectList.length>=1){
						if (this.commonJS.isEmpty(this.inputForm.projectList[0].projectId)){
							this.$message.error('第一行不能为空')
							return
						}
					}
					this.$refs.baseTable.insertAt({})
					this.inputForm.projectList.push({})
					this.baseKey = Math.random()
				}
				console.log('22',this.inputForm.projectList)
			},
			// 删除
			removeEvent(row, rowIndex, type) {
				if (type === 'base') {
					this.$refs.baseTable.remove(row)
					this.inputForm.projectList.splice(rowIndex, 1)
				}
			},
			openProgramPageForm(rowIndex) {
				this.$refs.projectForm.init('2',true)
				this.programRow = rowIndex
				console.log('11',this.programRow)
			},
			getProgram(rows) {
				console.log('1',rows)
				rows.forEach((item, index) => {
					this.inputForm.programId = item.id
					if (index === 0) {
						let r = this.inputForm.projectList[this.programRow]
						r.projectId=item.id
						r.name = item.name
						r.no = item.no
						r.leader = item.projectLeader
						r.createTime = item.createTime
						console.log('2',this.inputForm.projectList[this.programRow])
					} else {
						let r = {
							projectId: item.id,
							name: item.name,
							no: item.no,
							leader: item.projectLeader,
							createTime: item.createTime,
						}
						this.$refs.baseTable.insertAt(r)
						this.inputForm.projectList.push(r)
						this.baseKey = Math.random()
					}

				})
				this.$forceUpdate()
				this.programRow = ''
				// this.inputForm.reconciliationArea = this.inputForm.financeInvoiceBaseDTOList[0].location
			},

		}

	}
</script>
<style scoped>
	/deep/ .el-input-number .el-input__inner {
		text-align: left;
	}
	/deep/ .vxe-footer--row .vxe-footer--column:nth-child(1) .vxe-cell--item {
		font-weight:700;
	}
</style>
